Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Friends | List of all members
Connection Class Reference

Represents a single TCP or UDP socket for input or output. More...

`#include "connection.h"`

Inheritance diagram for Connection:

## Public Member Functions
| Connection (ConnectionManager *manager, Socket_IP *socket)
| Creates a connection.
| ~Connection ()
| Closes a connection.
bool | consider_flush ()
| Sends the most recently queued TCP datagram(s) if enough time has elapsed.
bool | flush ()
| Sends the most recently queued TCP datagram(s) now.
NetAddress | get_address () const
| Returns the address bound to this connection, if it is a TCP connection.
bool | get_collect_tcp () const
| Returns the current setting of "collect-tcp" mode.
double | get_collect_tcp_interval () const
| Returns the interval in time, in seconds, for which to hold TCP packets before sending all of the recently received packets at once.
ConnectionManager * | get_manager () const
| Returns a pointer to the ConnectionManager object that serves this connection.
Socket_IP * | get_socket () const
| Returns the internal Socket_IP that defines the connection.
void | set_collect_tcp (bool collect_tcp)
| Enables or disables "collect-tcp" mode.
void | set_collect_tcp_interval (double interval)
| Specifies the interval in time, in seconds, for which to hold TCP packets before sending all of the recently received packets at once.
void | set_ip_time_to_live (int ttl)
| Sets IP time-to-live.
void | set_ip_type_of_service (int tos)
| Sets IP type-of-service and precedence.
void | set_keep_alive (bool flag)
| Sets whether the connection is periodically tested to see if it is still alive.
void | set_linger (bool flag, double time)
| Sets whether nonblocking I/O should be in effect.
void | set_max_segment (int size)
| Sets the maximum segment size.
void | set_no_delay (bool flag)
| If flag is true, this disables the Nagle algorithm, and prevents delaying of send to coalesce packets.
void | set_recv_buffer_size (int size)
| Sets the size of the receive buffer, in bytes.
void | set_reuse_addr (bool flag)
| Sets whether local address reuse is allowed.
void | set_send_buffer_size (int size)
| Sets the size of the send buffer, in bytes.
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)

## Friends
class | ConnectionWriter

## Additional Inherited Members
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.

## Detailed Description

Represents a single TCP or UDP socket for input or output.

Definition at line 29 of file connection.h.

## Constructor & Destructor Documentation

## ◆ Connection()

Connection::Connection | ( | ConnectionManager * | manager,
|  | Socket_IP * | socket )
| explicit

Creates a connection.

Normally this constructor should not be used directly by user code; use one of the methods in ConnectionManager to make a new connection.

Definition at line 35 of file connection.cxx.

## ◆ ~Connection()

Connection::~Connection | ( |  | ) |

Closes a connection.

Definition at line 58 of file connection.cxx.

References flush().

## Member Function Documentation

## ◆ consider_flush()

bool Connection::consider_flush | ( |  | ) |

Sends the most recently queued TCP datagram(s) if enough time has elapsed.

This only has meaning if set_collect_tcp() has been set to true.

Definition at line 148 of file connection.cxx.

References TrueClock::get_global_ptr().

## ◆ flush()

bool Connection::flush | ( |  | ) |

Sends the most recently queued TCP datagram(s) now.

This only has meaning if set_collect_tcp() has been set to true.

Definition at line 172 of file connection.cxx.

Referenced by ~Connection(), and ConnectionManager::close_connection().

## ◆ get_address()

NetAddress Connection::get_address | ( |  | ) | const

Returns the address bound to this connection, if it is a TCP connection.

Definition at line 74 of file connection.cxx.

## ◆ get_collect_tcp()

bool Connection::get_collect_tcp | ( |  | ) | const

Returns the current setting of "collect-tcp" mode.

See set_collect_tcp().

Definition at line 119 of file connection.cxx.

## ◆ get_collect_tcp_interval()

double Connection::get_collect_tcp_interval | ( |  | ) | const

Returns the interval in time, in seconds, for which to hold TCP packets before sending all of the recently received packets at once.

This only has meaning if "collect-tcp" mode is enabled; see set_collect_tcp().

Definition at line 139 of file connection.cxx.

## ◆ get_manager()

ConnectionManager * Connection::get_manager | ( |  | ) | const

Returns a pointer to the ConnectionManager object that serves this connection.

Definition at line 84 of file connection.cxx.

## ◆ get_socket()

Socket_IP * Connection::get_socket | ( |  | ) | const

Returns the internal Socket_IP that defines the connection.

Definition at line 92 of file connection.cxx.

Referenced by ConnectionManager::close_connection(), ConnectionWriter::send(), and ConnectionWriter::send().

## ◆ set_collect_tcp()

void Connection::set_collect_tcp | ( | bool | collect_tcp | ) |

Enables or disables "collect-tcp" mode.

In this mode, individual TCP packets are not sent immediately, but rather they are collected together and accumulated to be sent periodically as one larger TCP packet. This cuts down on overhead from the TCP/IP protocol, especially if many small packets need to be sent on the same connection, but it introduces additional latency (since packets must be held before they can be sent).

See set_collect_tcp_interval() to specify the interval of time for which to hold packets before sending them.

If you enable this mode, you may also need to periodically call consider_flush() to flush the queue if no packets have been sent recently.

Definition at line 111 of file connection.cxx.

## ◆ set_collect_tcp_interval()

void Connection::set_collect_tcp_interval | ( | double | interval | ) |

Specifies the interval in time, in seconds, for which to hold TCP packets before sending all of the recently received packets at once.

This only has meaning if "collect-tcp" mode is enabled; see set_collect_tcp().

Definition at line 129 of file connection.cxx.

## ◆ set_ip_time_to_live()

void Connection::set_ip_time_to_live | ( | int | ttl | ) |

Sets IP time-to-live.

Definition at line 256 of file connection.cxx.

## ◆ set_ip_type_of_service()

void Connection::set_ip_type_of_service | ( | int | tos | ) |

Sets IP type-of-service and precedence.

Definition at line 264 of file connection.cxx.

## ◆ set_keep_alive()

void Connection::set_keep_alive | ( | bool | flag | ) |

Sets whether the connection is periodically tested to see if it is still alive.

Definition at line 229 of file connection.cxx.

## ◆ set_linger()

void Connection::set_linger | ( | bool | flag,
|  | double | time )

Sets whether nonblocking I/O should be in effect.

Sets the time to linger on close if data is present. If flag is false, when you close a socket with data available the system attempts to deliver the data to the peer (the default behavior). If flag is false but time is zero, the system discards any undelivered data when you close the socket. If flag is false but time is nonzero, the system waits up to time seconds to deliver the data.

Definition at line 205 of file connection.cxx.

References Socket_TCP::DontLinger(), and Socket_TCP::SetLinger().

## ◆ set_max_segment()

void Connection::set_max_segment | ( | int | size | ) |

Sets the maximum segment size.

Definition at line 284 of file connection.cxx.

## ◆ set_no_delay()

void Connection::set_no_delay | ( | bool | flag | ) |

If flag is true, this disables the Nagle algorithm, and prevents delaying of send to coalesce packets.

Definition at line 273 of file connection.cxx.

References Socket_TCP::SetNoDelay().

## ◆ set_recv_buffer_size()

void Connection::set_recv_buffer_size | ( | int | size | ) |

Sets the size of the receive buffer, in bytes.

Definition at line 237 of file connection.cxx.

## ◆ set_reuse_addr()

void Connection::set_reuse_addr | ( | bool | flag | ) |

Sets whether local address reuse is allowed.

Definition at line 220 of file connection.cxx.

## ◆ set_send_buffer_size()

void Connection::set_send_buffer_size | ( | int | size | ) |

Sets the size of the send buffer, in bytes.

Definition at line 245 of file connection.cxx.

References Socket_TCP::SetSendBufferSize().

## Friends And Related Symbol Documentation

## ◆ ConnectionWriter

friend class ConnectionWriter
| friend

Definition at line 74 of file connection.h.

The documentation for this class was generated from the following files:

- panda/src/net/connection.h
- panda/src/net/connection.cxx